/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 11:59:12 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.kestore;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Walther Neuper Sep 7, 2004, 11:59:12 AM
 *  
 */
public class TestKEStoreServices extends TestCase {

	public void testLoadContentMinisubpbl() {
		System.out
				.println("---BEGIN isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl");
		Vector test = null;

		KEStoreServices ks = new KEStoreServices(
				"isac/src/java-tests/isac/kestore/data");
		Vector vec = ks.loadContent("exp", "exp_IsacCore_Tests_1b.xml");

		File f = new File("isac/src/java-tests/isac/kestore/data/exp",
				"exp_IsacCore_Tests_1b.Vector");
		//		created by this (JUST DECOMMENT !)
		//		try {
		//			ObjectOutputStream oos =
		//				new ObjectOutputStream(new FileOutputStream(f));
		//			oos.writeObject(vec);
		//			oos.close();
		//		} catch (IOException e) {
		//			e.printStackTrace();
		//		}
		try {
			ObjectInputStream ois = new ObjectInputStream(
					new FileInputStream(f));
			test = (Vector) ois.readObject();
			ois.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		assertEquals("KEStoreServices.loadContent: xml ---> Vector", test, vec);

		System.out
				.println("---END isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl");
	}

}