/*
 * Created on Oct 31, 2003
*/
package isac.util.formulae;

import isac.util.formulae.*;

import java.io.Serializable;

/**
 * @author rgradisc
 */

public class Specification implements Serializable {
  protected CalcHeadSimpleID theory_;
  protected CalcHeadCompoundID problem_, method_;

  public String toSMLString() {
    StringBuffer sb = new StringBuffer();
    sb.append(getTheory().getQuotedID());
    sb.append(",");
    sb.append(getProblem().toSMLString());
    sb.append(",");
    sb.append(getMethod().toSMLString());
    return sb.toString();
  }

  public CalcHeadSimpleID getTheory() {
    return theory_;
  }

  public CalcHeadCompoundID getMethod() {
    return method_;
  }

  public CalcHeadCompoundID getProblem() {
    return problem_;//(ProblemID)problem_    ---> ClassCastException LK?
  }

  public void setTheory(CalcHeadSimpleID el) {
    theory_ = el;
  }

  public void setProblem(CalcHeadCompoundID el) {
    problem_ = el;
  }

  public void setMethod(CalcHeadCompoundID el) {
    method_ = el;
  }
	public String toString(){
		String content="<SPECIFICATION>\n";
		if(theory_!=null){
			content+="<THEORY>\n"+theory_+"</THEORY>\n";
		}
		if(problem_!=null)
			content+="<PROBLME>\n"+problem_+"</PROBLEM>\n";
		if(method_!=null)
			content+="<METHOD>\n"+method_+"</METHOD>\n";
		content+="</SPECIFICATION>\n";
		return content;
	}
}
