/*
 * Created on Feb 6, 2004
 */
package isac.wsdialog;


/**
 * Describes an action which has to pass a UI Element,
 * e.g a activation or deactivating buttons.
 * @see isac.wsdialog.IUIElement
 * @author Alan Krempler
 */
public class ActionOnUIElement extends UserAction {
	private int ui_element_id_;
	
	public ActionOnUIElement(int id, int ui_element_id) {
		super(id);
		ui_element_id_ = ui_element_id; 
	}
	
	public int getUIElementId() {
		return ui_element_id_;
	}
}
