/*
 * Created on Dec 12, 2003
 */
package isac.wsdialog;

/**
 * Notification about the user clicking a GUI element.
 * 
 * @author Alan Krempler
 */
public class UserAction implements IUserAction {

	private int id_;
	
	/**
	 * TODO: move class subtree (including IUserAction) to package isac.gui.worksheet?
	 * This way, the constructors could be package-private to the 
	 * objects which construct them.
	 * 
	 * @param id An integer value describing the action the user requested on the GUI
	 */
	public UserAction(int id) {
		id_=id;
	}
	
	public int getActionID() {
		return id_;
	}
}
