/*
 * Created on Oct 6, 2003
 */
package isac.session;


import isac.browserdialog.BDialog;
import isac.wsdialog.DGuide;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author gismo
 */
public interface OManager extends Remote{
	/**
	 * fetch the SessionDialog of the system - multiple calls to this method result in one and 
	 * the same SessionDialog.
	 */
	public abstract SDialog getSessionDialog() throws RemoteException;
	/**
	 *  fetch the BrowserDialog identified by <code>bdialog_id</code>
	 */
	public abstract BDialog getBrowserDialog(String id) throws RemoteException;
	/**
	 * fetch the WorksheetDialog identified by <code>wdialog_id</code>
	 */
	public abstract DGuide getWorksheetDialog(String id) throws RemoteException;
}