<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <xsl:text>
      var menu=null;
      menu=new MTMenu();
      menu.addItem("</xsl:text>
    <xsl:value-of select="normalize-space(//NODE/ID)"/>
    <xsl:text>");</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>
      menu.makeLastSubmenu(a);
    </xsl:text>
  </xsl:template>

  <xsl:template match="NODE">
    <xsl:text>var </xsl:text>
    <xsl:number level="multiple" format="a_1_1_1_1_1_1_1_1_1_1"/>
    <xsl:text> = null;
  </xsl:text>
    <xsl:number level="multiple" format="a_1_1_1_1_1_1_1_1_1_1"/>
    <xsl:text>=new MTMenu();
  </xsl:text>
    <xsl:for-each select="NODE">
      <xsl:for-each select="parent::*">
        <xsl:number  level="multiple" format="a_1_1_1_1_1_1_1_1_1_1"/>        
      </xsl:for-each>
      <xsl:text>.addItem("</xsl:text>
      <xsl:value-of select="normalize-space(ID)"/>
      <xsl:text>", "file:///home/neuper/proto2/www/kbase/met/</xsl:text>  
      <xsl:value-of select="normalize-space(CONTENTREF)"/>
      <xsl:text>.html");</xsl:text>
      <xsl:apply-templates select = "."/>
    </xsl:for-each>
    <xsl:if test="../ID">
      <xsl:if test="descendant::ID">        
      <xsl:for-each select="parent::*">
        <xsl:number  level="multiple" format="a_1_1_1_1_1_1_1_1_1_1"/>        
      </xsl:for-each>
     <xsl:text>.makeLastSubmenu(</xsl:text>
    <xsl:number level="multiple" format="a_1_1_1_1_1_1_1_1_1_1"/>
    <xsl:text>);
  </xsl:text>
      </xsl:if>

    </xsl:if>

    <!--    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>met/</xsl:text>
        <xsl:value-of select="normalize-space(CONTENTREF)"/></xsl:attribute>
        <xsl:value-of select="ID"/>
      </xsl:element>    
      -->
  </xsl:template>

  <xsl:template match="ID"/>
  <xsl:template match="CONTENTREF"/>

</xsl:stylesheet>
