(* use"Scripts/ListG.ML";
   W.N. 8.01
*)

"---------";

theory' := overwritel (!theory', 
		       [("ListG.thy",ListG.thy)]);
(*rule set for listexpr in scripts:
  in knowledge/interface_ME_ISA.sml .. needs eval_binop from Atools.ML
*)
theorem' := overwritel (!theorem',
			[("length_Cons_",num_str length_Cons_),
			 ("length_Nil_",num_str length_Nil_)]);


(** rule set for evaluating listexpr in scripts FIXXXME -> ListG.ML**)
val list_rls = 
  Rls{id="list_rls",preconds = [], rew_ord = ("dummy_ord",dummy_ord), 
      erls = e_rls, srls = Erls, calc = [], (*asm_thm=[],*)
      rules = (*8.01: copied from*)
      [Thm ("refl", num_str refl),       (*'a<>b -> FALSE' by fun eval_equal*)
       Thm ("o_apply", num_str o_apply),

       Thm ("nth_Cons_",num_str nth_Cons_),(*erls for cond. in Atools.ML*)
       Thm ("nth_Nil_",num_str nth_Nil_),
       Thm ("append_Cons",num_str append_Cons),
       Thm ("append_Nil",num_str append_Nil),
       Thm ("butlast_Cons",num_str butlast_Cons),
       Thm ("butlast_Nil",num_str butlast_Nil),
       Thm ("concat_Cons",num_str concat_Cons),
       Thm ("concat_Nil",num_str concat_Nil),
       Thm ("del_base",num_str del_base),
       Thm ("del_rec",num_str del_rec),

       Thm ("distinct_Cons",num_str distinct_Cons),
       Thm ("distinct_Nil",num_str distinct_Nil),
       Thm ("dropWhile_Cons",num_str dropWhile_Cons),
       Thm ("dropWhile_Nil",num_str dropWhile_Nil),
       Thm ("filter_Cons",num_str filter_Cons),
       Thm ("filter_Nil",num_str filter_Nil),
       Thm ("foldr_Cons",num_str foldr_Cons),
       Thm ("foldr_Nil",num_str foldr_Nil),
       Thm ("hd_thm",num_str hd_thm),
       Thm ("last_thm",num_str last_thm),
       Thm ("length_Cons_",num_str length_Cons_),
       Thm ("length_Nil_",num_str length_Nil_),
       Thm ("list_diff_def",num_str list_diff_def),
       Thm ("map_Cons",num_str map_Cons),
       Thm ("map_Nil",num_str map_Cons),
       Thm ("mem_Cons",num_str mem_Cons),
       Thm ("mem_Nil",num_str mem_Nil),
       Thm ("null_Cons",num_str null_Cons),
       Thm ("null_Nil",num_str null_Nil),
       Thm ("remdups_Cons",num_str remdups_Cons),
       Thm ("remdups_Nil",num_str remdups_Nil),
       Thm ("rev_Cons",num_str rev_Cons),
       Thm ("rev_Nil",num_str rev_Nil),
       Thm ("take_Nil",num_str take_Nil),
       Thm ("take_Cons",num_str take_Cons),
       Thm ("tl_Cons",num_str tl_Cons),
       Thm ("tl_Nil",num_str tl_Nil),
       Thm ("zip_Cons",num_str zip_Cons),
       Thm ("zip_Nil",num_str zip_Nil)
       ], scr = EmptyScr}:rls;

ruleset' := overwritel (!ruleset',
  [("list_rls",list_rls)
   ]);
