(* use"systest/list_rls.sml";
   use"list_rls.sml";
   WN.1.5.03
   *)
"--------------------- nth_ ----------------------------------------------";
"--------------------- length_ -------------------------------------------";
"--------------------- 29.4.03: union ------------------------------------";
"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";



"--------------------- nth_ ----------------------------------------------";
"--------------------- nth_ ----------------------------------------------";
"--------------------- nth_ ----------------------------------------------";
val t = str2term "nth_ 3 [a,b,c,d,e]";
atomty thy t;
val thm = (#prop o rep_thm o num_str) nth_Cons_;
atomty thy thm;
val Some (t',_) = rewrite_ thy dummy_ord Poly_erls false (num_str nth_Cons_) t;
term2str t';
"nth_ (3 + -1) [b, c, d, e]";

val t = str2term "nth_ 1 [a,b,c,d,e]";
atomty thy t;
val thm = (#prop o rep_thm o num_str) nth_Nil_;
atomty thy thm;
val Some (t',_) = rewrite_ thy dummy_ord Poly_erls false (num_str nth_Nil_) t;
term2str t';
"a";

val t = str2term "nth_ 3 [a,b,c,d,e]";
atomty thy t;
trace_rewrite:=true;
val Some (t',_) = rewrite_set_ thy false list_rls t;
trace_rewrite:=false;
term2str t';
"c";

(*-------------------------------------------------------------------*)
val Some (Thm (_,thm)) = rls_get_thm list_rls "nth_Nil_";
val ttt = (#prop o rep_thm) thm;
atomty thy ttt;
(*Free ( 1, real)   ...OK, Var ((x, 0), ?'a) OK*)



"--------------------- length_ -------------------------------------------";
"--------------------- length_ -------------------------------------------";
"--------------------- length_ -------------------------------------------";
val thy' = "ListG.thy";
val ct = "length_ [1,1,1]";
val thm = ("length_Cons_","");
val (ct,asm) = the (rewrite thy' "tless_true" ("tval_rls") false thm ct);
val (ct,asm) = the (rewrite thy' "tless_true" ("tval_rls") false thm ct);
val (ct,asm) = the (rewrite thy' "tless_true" ("tval_rls") false thm ct);
val thm = ("length_Nil_","");
val (ct,asm) = the (rewrite thy' "tless_true" ("tval_rls") false thm ct);
if ct="1 + (1 + (1 + 0))"then()
else raise error ("list_rls.sml 1: behaviour of test-expl changed: "^ct);


val ct = "length_ [1,1,1]";
val rls = "list_rls";
val (ct,asm) = the (rewrite_set thy' false rls ct);
if ct="3"then()
else raise error ("list_rls.sml 2: behaviour of test-expl changed: "^ct);


val ct = "length_ [1,1,1]";
val t = (term_of o the o (parse ListG.thy)) ct;
val t = eval_listexpr_ ListG.thy list_rls t;
case t of Free ("3",_) => () 
| _ => raise error ("list-rls.sml 3: behaviour of test-expl changed: "^ct);


"--------------------- 29.4.03: union ------------------------------------";
"--------------------- 29.4.03: union ------------------------------------";
"--------------------- 29.4.03: union ------------------------------------";

fun ins_ x xs = if x mem xs then xs else x :: xs;
fun union_ xs [] = xs
  | union_ [] ys = ys
  | union_ (x :: xs) ys = union_ xs (ins_ x ys);


val t = (term_of o the o (parse ListG.thy)) "1 mem []";
atomty thy t;




"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
str2term
  "Script Maximum_value(fix_::bool list)(m_::real) (rs_::bool list)\
   \      (v_::real) (itv_::real set) (err_::bool) =          \ 
   \ (let e_ = (hd o (filterVar m_)) rs_;              \
   \      t_ = (if 1 < length_ rs_                            \
   \           then (SubProblem (Reals_,[make,function],[no_met])\
   \                     [real_ m_, real_ v_, bool_list_ rs_])\
   \           else (hd rs_));                                \
   \      (mx_::real) = SubProblem (Reals_,[on_interval,max_of,function], \
   \                                [Isac,maximum_on_interval])\
   \                               [bool_ t_, real_ v_, real_set_ itv_]\
   \ in ((SubProblem (Reals_,[find_values,tool],[Isac,find_values])   \
   \      [real_ mx_, real_ (Rhs t_), real_ v_, real_ m_,     \
   \       bool_list_ (dropWhile (ident e_) rs_)])::bool list))";

val fix_ = (str2term "fix_::bool list", 
	    str2term "[r=Arbfix]");
val m_   = (str2term "m_::real", 
	    str2term "A");
val rs_  = (str2term "rs_::bool list", 
	    str2term "[A = a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]");
val v_   = (str2term "v_::real", 
	    str2term "b");
val itv_ = (str2term "itv_::real set", 
	    str2term "{x::real. 0 <= x & x <= 2*r}");
val err_ = (str2term "err_::bool", 
	    str2term "eps=0");
val env = [fix_, m_, rs_ ,v_, itv_, err_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar m_)) (rs_::bool list)";
val s = subst_atomic env t;
term2str s;
"(hd o filterVar A) [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val Some (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s''="A = a * b" then () else raise error "new behaviour with list_rls 1.1.";
val env = env @ [(str2term "e_::bool",str2term "A = a * b")];

(*--- 2.line: condition alone ---*)
val t = str2term "1 < length_ (rs_::bool list)";
val s = subst_atomic env t;
term2str s;
"1 < length_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val Some (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s''="True" then () else raise error "new behaviour with list_rls 1.2.";

(*--- 2.line in script ---*)
val t = str2term 
	    "(if 1 < length_ rs_                            \
   \           then (SubProblem (Reals_,[make,function],[no_met])\
   \                     [real_ m_, real_ v_, bool_list_ rs_])\
   \           else (hd rs_))";
val s = subst_atomic env t;
term2str s;
"if 1 < length_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]\
\then SubProblem (Reals_, [make, function], [no_met])\
\      [real_ A, real_ b,\
\       bool_list_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]]\
\else hd [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val Some (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s'' = 
"SubProblem (Reals_, [make, function], [no_met])\n\
\ [real_ A, real_ b,\n\
\  bool_list_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]]" then ()
else raise error "new behaviour with list_rls 1.3.";
val env = env @ [(str2term "t_::bool",
		  str2term "A = (2*sqrt(r^^^2-(b/2)^^^2)) * b")];



"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
str2term
   "Script Make_fun_by_explicit (f_::real) (v_::real)         \
   \      (eqs_::bool list) =                                 \
   \ (let h_  = (hd o (filterVar f_)) eqs_;                   \
   \      e_1 = hd (dropWhile (ident h_) eqs_);               \
   \      vs_ = dropWhile (ident f_) (Vars h_);                \
   \      v_1 = hd (dropWhile (ident v_) vs_);                \
   \      (s_1::bool list)=(SubProblem(Reals_,[univar,equation],[no_met])\
   \                          [bool_ e_1, real_ v_1])\
   \ in Substitute [(v_1, (rhs o hd) s_1)] h_)";
val f_ = (str2term "f_::real", 
	  str2term "A");
val v_ = (str2term "v_::real", 
	  str2term "b");
val eqs_=(str2term "eqs_::bool list", 
	  str2term "[A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]");
val env = [f_, v_, eqs_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar v_)) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
     "(hd o filterVar b) [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "A = a * b" then () else raise error "new behaviour with list_rls 2.1";
val env = env @ [(str2term "h_::bool", str2term s')];

(*--- 2.line in script ---*)
val t = str2term "hd (dropWhile (ident h_) (eqs_::bool list))";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	    "hd (dropWhile (ident (A = a * b))\
	    \     [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2])";
mem_rls "dropWhile_Cons" list_rls;
mem_rls "Atools.ident" list_rls;
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "(a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2" then () 
else raise error "new behaviour with list_rls 2.2";
val env = env @ [(str2term "e_1::bool", str2term s')];

(*--- 3.line in script ---*)
val t = str2term "dropWhile (ident f_) (Vars (h_::bool))";
val s = subst_atomic env t;
term2str s;
val t = str2term "dropWhile (ident A) (Vars (A = a * b))";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a, b]" then () else raise error "new behaviour with list_rls 2.3";
val env = env @ [(str2term "vs_::real list", str2term s')];

(*--- 4.line in script ---*)
val t = str2term "hd (dropWhile (ident v_) vs_)";
val s = subst_atomic env t;
term2str s;
val t = str2term "hd (dropWhile (ident b) [a, b])";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a" then () else raise error "new behaviour with list_rls 2.4.";
val env = env @ [(str2term "v_1::real", str2term s')];

(*--- 5.line in script ---*)
val t = str2term "(SubProblem(Reals_,[univar,equation],[no_met])\
		 \           [bool_ e_1, real_ v_1])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\n\
\ [bool_ ((a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2), real_ a]";
val env = env @ [(str2term "s_1::bool list", 
		  str2term "[a = 2 * sqrt (r^^^2 - (b/2)^^^2)]")];

(*--- 6.line in script ---*)
val t = str2term "Substitute [(v_1, (rhs o hd) (s_1::bool list))] (h_::bool)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"Substitute [(a, (rhs o hd) [a = 2 * sqrt (r ^^^ 2 - (b / 2) ^^^ 2)])]\n\
\ (A = a * b)";
mem_rls "Tools.rhs" list_rls;
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "Substitute [(a, 2 * sqrt (r ^^^ 2 - (b / 2) ^^^ 2))] (A = a * b)" 
then () else raise error "new behaviour with list_rls 2.6.";


"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
str2term
  "Script Make_fun_by_new_variable (f_::real) (v_::real)     \
   \      (eqs_::bool list) =                                 \
   \(let h_ = (hd o (filterVar f_)) eqs_;             \
   \     es_ = dropWhile (ident h_) eqs_;                    \
   \     vs_ = dropWhile (ident f_) (Vars h_);                \
   \     v_1 = nth_ 1 vs_;                                   \
   \     v_2 = nth_ 2 vs_;                                   \
   \     e_1 = (hd o (filterVar v_1)) es_;            \
   \     e_2 = (hd o (filterVar v_2)) es_;            \
   \  (s_1::bool list) = (SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_1, real_ v_1]);\
   \  (s_2::bool list) = (SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_2, real_ v_2])\
   \in Substitute [(v_1, (rhs o hd) s_1),(v_2, (rhs o hd) s_2)] h_)";
val f_ = (str2term "f_::real", 
	  str2term "A");
val v_ = (str2term "v_::real", 
	  str2term "alpha");
val eqs_=(str2term "eqs_::bool list", 
	  str2term "[A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]");
val env = [f_, v_, eqs_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar (f_::real))) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"(hd o filterVar A) [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
trace_rewrite:=true;
val Some (t',_) = rewrite_set_ thy false list_rls t;
trace_rewrite:=false;
val s' = term2str t';
if s' = "A = a * b" then() else raise error "new behaviour with list_rls 3.1.";
val env = env @ [(str2term "h_::bool", str2term s')];

(*--- 2.line in script ---*)
val t = str2term "dropWhile (ident (h_::bool)) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"dropWhile (ident (A = a * b))\
\ [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a / 2 = r * sin alpha, b / 2 = r * cos alpha]" 
then () else raise error "new behaviour with list_rls 3.2.";
val env = env @ [(str2term "es_::bool list", str2term s')];

(*--- 3.line in script ---*)
val t = str2term "dropWhile (ident (f_::real)) (Vars (h_::bool))";
val s = subst_atomic env t;
term2str s;
val t = str2term "dropWhile (ident A) (Vars (A = a * b))";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a, b]" then () else raise error "new behaviour with list_rls 3.3.";
val env = env @ [(str2term "vs_::real list", str2term s')];

(*--- 4.line in script ---*)
val t = str2term "nth_ 1 vs_";
val s = subst_atomic env t;
term2str s;
val t = str2term "nth_ 1 [a, b]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a" then () else raise error "new behaviour with list_rls 3.4.";
val env = env @ [(str2term "v_1", str2term s')];

(*--- 5.line in script ---*)
val t = str2term "nth_ 2 vs_";
val s = subst_atomic env t;
term2str s;
val t = str2term "nth_ 2 [a, b]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "b" then () else raise error "new behaviour with list_rls 3.5.";
val env = env @ [(str2term "v_2", str2term s')];

(*--- 6.line in script ---*)
val t = str2term "(hd o (filterVar v_1)) (es_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	   "(hd o filterVar a) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a / 2 = r * sin alpha" then () 
else raise error "new behaviour with list_rls 3.6.";
val e_1 = str2term "e_1::bool";
val env = env @ [(e_1, str2term s')];

(*--- 7.line in script ---*)
val t = str2term "(hd o (filterVar v_2)) (es_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	  "(hd o filterVar b) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val Some (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "b / 2 = r * cos alpha" then () 
else raise error "new behaviour with list_rls 3.7.";
val env = env @ [(str2term "e_2::bool", str2term s')];

(*--- 8.line in script ---*)
val t = str2term "(SubProblem (Reals_,[univar,equation],[no_met])\
		 \            [bool_ e_1, real_ v_1])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\
	    \ [bool_ (a / 2 = r * sin alpha), real_ a]";
val s_1 = str2term "[a = 2*r*sin alpha]";
val env = env @ [(str2term "s_1::bool list", s_1)];

(*--- 9.line in script ---*)
val t = str2term "(SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_2, real_ v_2])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\
	    \ [bool_ (b / 2 = r * cos alpha), real_ b]";
val s_2 = str2term "[b = 2*r*cos alpha]";
val env = env @ [(str2term "s_2::bool list", s_2)];

(*--- 10.line in script ---*)
val t = str2term 
"Substitute [(v_1, (rhs o hd) s_1),(v_2, (rhs o hd) s_2)] (h_::bool)";
val s = subst_atomic env t;
term2str s;
"Substitute\n [(a, (rhs o hd) [a = 2 * r * sin alpha]),\
\              (b, (rhs o hd) [b = 2 * r * cos alpha])] (A = a * b)";
val Some (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s'' = 
"Substitute [(a, 2 * r * sin alpha), (b, 2 * r * cos alpha)] (A = a * b)"
then () else raise error "new behaviour with list_rls 3.10.";








(*--- .line in script -------------------------------------------------
val t = str2term "";
val s = subst_atomic env t;
term2str s;
val Some (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s'' = ... then () else raise error "new behaviour ...";
val env = env @ [(str2term "", s'')];--------------------------------*)

